package com.hfkj.dao;

import com.hfkj.entity.AuditMsg;
import com.hfkj.entity.AuditMsgExample.Criteria;
import com.hfkj.entity.AuditMsgExample.Criterion;
import com.hfkj.entity.AuditMsgExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class AuditMsgSqlProvider {

    public String countByExample(AuditMsgExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("audit_msg");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(AuditMsgExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("audit_msg");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(AuditMsg record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("audit_msg");
        
        if (record.getType() != null) {
            sql.VALUES("`type`", "#{type,jdbcType=INTEGER}");
        }
        
        if (record.getSubmitObjectId() != null) {
            sql.VALUES("submit_object_id", "#{submitObjectId,jdbcType=BIGINT}");
        }
        
        if (record.getSubmitObjectName() != null) {
            sql.VALUES("submit_object_name", "#{submitObjectName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubmitOpName() != null) {
            sql.VALUES("submit_op_name", "#{submitOpName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubmitOpId() != null) {
            sql.VALUES("submit_op_id", "#{submitOpId,jdbcType=BIGINT}");
        }
        
        if (record.getAuditSerialNo() != null) {
            sql.VALUES("audit_serial_no", "#{auditSerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRemarks() != null) {
            sql.VALUES("remarks", "#{remarks,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getAuditOpId() != null) {
            sql.VALUES("audit_op_id", "#{auditOpId,jdbcType=BIGINT}");
        }
        
        if (record.getAuditOpName() != null) {
            sql.VALUES("audit_op_name", "#{auditOpName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(AuditMsgExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("`type`");
        sql.SELECT("submit_object_id");
        sql.SELECT("submit_object_name");
        sql.SELECT("submit_op_name");
        sql.SELECT("submit_op_id");
        sql.SELECT("audit_serial_no");
        sql.SELECT("remarks");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("audit_op_id");
        sql.SELECT("audit_op_name");
        sql.SELECT("`status`");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("audit_msg");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        AuditMsg record = (AuditMsg) parameter.get("record");
        AuditMsgExample example = (AuditMsgExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("audit_msg");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        }
        
        if (record.getSubmitObjectId() != null) {
            sql.SET("submit_object_id = #{record.submitObjectId,jdbcType=BIGINT}");
        }
        
        if (record.getSubmitObjectName() != null) {
            sql.SET("submit_object_name = #{record.submitObjectName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubmitOpName() != null) {
            sql.SET("submit_op_name = #{record.submitOpName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubmitOpId() != null) {
            sql.SET("submit_op_id = #{record.submitOpId,jdbcType=BIGINT}");
        }
        
        if (record.getAuditSerialNo() != null) {
            sql.SET("audit_serial_no = #{record.auditSerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRemarks() != null) {
            sql.SET("remarks = #{record.remarks,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getAuditOpId() != null) {
            sql.SET("audit_op_id = #{record.auditOpId,jdbcType=BIGINT}");
        }
        
        if (record.getAuditOpName() != null) {
            sql.SET("audit_op_name = #{record.auditOpName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("audit_msg");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        sql.SET("submit_object_id = #{record.submitObjectId,jdbcType=BIGINT}");
        sql.SET("submit_object_name = #{record.submitObjectName,jdbcType=VARCHAR}");
        sql.SET("submit_op_name = #{record.submitOpName,jdbcType=VARCHAR}");
        sql.SET("submit_op_id = #{record.submitOpId,jdbcType=BIGINT}");
        sql.SET("audit_serial_no = #{record.auditSerialNo,jdbcType=VARCHAR}");
        sql.SET("remarks = #{record.remarks,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("audit_op_id = #{record.auditOpId,jdbcType=BIGINT}");
        sql.SET("audit_op_name = #{record.auditOpName,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        AuditMsgExample example = (AuditMsgExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(AuditMsg record) {
        SQL sql = new SQL();
        sql.UPDATE("audit_msg");
        
        if (record.getType() != null) {
            sql.SET("`type` = #{type,jdbcType=INTEGER}");
        }
        
        if (record.getSubmitObjectId() != null) {
            sql.SET("submit_object_id = #{submitObjectId,jdbcType=BIGINT}");
        }
        
        if (record.getSubmitObjectName() != null) {
            sql.SET("submit_object_name = #{submitObjectName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubmitOpName() != null) {
            sql.SET("submit_op_name = #{submitOpName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubmitOpId() != null) {
            sql.SET("submit_op_id = #{submitOpId,jdbcType=BIGINT}");
        }
        
        if (record.getAuditSerialNo() != null) {
            sql.SET("audit_serial_no = #{auditSerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRemarks() != null) {
            sql.SET("remarks = #{remarks,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getAuditOpId() != null) {
            sql.SET("audit_op_id = #{auditOpId,jdbcType=BIGINT}");
        }
        
        if (record.getAuditOpName() != null) {
            sql.SET("audit_op_name = #{auditOpName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, AuditMsgExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}